<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\FoodRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\Food;

class FoodController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/foods';
    /** View folder */
    private $viewDirectory= 'admin.foods.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('foods.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the foods.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
       $ids = Food::pluck('user_id');
        $query = User::whereIn('id',$ids)->orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $foods= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('foods'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('foods.store');
        $head = metaFields('foods', 'add_new', getCurrentLocale()) ?? __('foods.new');
    $patients = User::where('role_id','6')->get();

        return view( $this->viewDirectory.'form', compact('action', 'head','patients') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param FoodRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(FoodRequest $request) :RedirectResponse
    {
     //dd($request->all());
        $this->saveData( $request, $request->user_id );

        
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Food  $food
     * @return View
     */
    public function edit(User $food): View
    {
        $action= route('foods.update', $food->id);
        $head = metaFields('foods', 'edit', getCurrentLocale()) ?? __('foods.edit');
        $patients = User::where('role_id','6')->get();
        $foods = Food::where('user_id',$food->id)->get();
        
        return view( $this->viewDirectory.'form', compact('food', 'foods','action', 'head','patients') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  FoodRequest  $request
     * @param  Food  $food
     * @return RedirectResponse|Redirector
     */
    public function update(FoodRequest $request, User $food) :RedirectResponse
    {
      
        $foods = Food::where('user_id',$food->id)->delete();
        $this->saveData( $request, $request->user_id );

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
     private function saveData(Request $request, int $id ):void
    {
        
       if (!is_null($request->food))
       {
           
            foreach ($request->food as $row)
            {
                if(is_null($row['dating'])){
                    $date = date('Y-m-d');
                }
                else{
                    $date = $row['dating'];
                }
              Food::create([
            'user_id'=>$id,
            'dating'=>$date,
            'name'=>$row['name'],
            'type'=>$row['type'],
                                            ]);





            
              
            }
        }

    }
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = Food::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Food::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Food::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = Food::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = Food::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
